package com.css.simulation.resource.server.infra.db.mysql.mapper;

import api.common.pojo.param.project.MultiSimulationSceneCarParam;
import api.common.pojo.param.project.MultiSimulationSceneParam;
import api.common.pojo.po.project.MultiSimulationScenePO;
import api.common.pojo.vo.project.MultiSimulationSceneCarVO;
import api.common.pojo.vo.project.MultiSimulationSceneVO;
import org.apache.ibatis.annotations.*;

import java.util.List;

@Mapper
public interface MultiSimulationSceneCarMapper {
    @Insert("insert into multi_simulation_scene_car (id,scene_id,car_id,algorithm_id,path_id,path_start,path_end,path_start_point,path_end_point,car_sort,is_simulation_car) values" +
        "(#{sceneCarId},#{sceneId},#{carId},#{algorithmId},#{pathId},#{pathStart},#{pathEnd},#{pathStartPoint},#{pathEndPoint},#{carSort},#{isSimulationCar})")
    int addMultiSimulationSceneCar(MultiSimulationSceneCarParam param);

    @Select("select count(*) from multi_simulation_scene_car where scene_id = #{sceneId} and deleted = 0")
    int selectSceneCarNumsBySceneId(@Param("sceneId") String sceneId);


    @Update("<script>" +
        "update multi_simulation_scene_car set car_id = #{carId},algorithm_id = #{algorithmId}, path_id = #{pathId}," +
        "path_start = #{pathStart},path_end = #{pathEnd},path_start_point = #{pathStartPoint},path_end_point = #{pathEndPoint},car_sort = #{carSort} " +
        "where id = #{sceneCarId}" +
        "</script>")
    int updateMultiSimulationSceneCar(MultiSimulationSceneCarParam param);

    @Update("<script>" +
        "update multi_simulation_scene_car set is_simulation_car = #{isSimulationCar} " +
        "where id = #{id}" +
        "</script>")
    int updateMultiSimulationSceneCarView(@Param("id") String id, @Param("isSimulationCar") Integer isSimulationCar);

    @Update("update multi_simulation_scene_car set deleted = 1 where id = #{sceneCarId}")
    int deleteMultiSimulationSceneCar(MultiSimulationSceneCarParam param);
//
    @Select("<script>" +
        "select id,sceneId,carId,algorithmId,pathId,pathStart,pathEnd,pathStartPoint,pathEndPoint,carSort,createTime from multi_simulation_scene_car where deleted = 0 " +
        "and scene_id = #{sceneId}" +
        "order by carSort, create_time desc" +
        "</script>")
    List<MultiSimulationSceneCarVO> selectSceneCarList(MultiSimulationSceneCarParam param);

    @Select("<script>" +
        "select id,sceneId,carId,algorithmId,pathId,pathStart,pathEnd,pathStartPoint,pathEndPoint,carSort,createTime from multi_simulation_scene_car where deleted = 0 " +
        "and id = #{sceneCarId}" +
        "</script>")
    MultiSimulationSceneCarVO selectSceneCarById(MultiSimulationSceneCarParam param);

}
